apiVersion: argoproj.io/v1alpha1
kind: Workflow
metadata:
  name: fifa-ci
spec:
  entrypoint: startdag
  arguments:
    parameters:
      - name: revision
        value: main

  templates:
    - name: startdag
      dag:
        tasks:
          - name: deploy
            templateRef:
              name: wf-dvb-deploy
              template: wf-dvb-deploy
          - name: airbyte
            templateRef:
              name: wf-elt-run
              template: wf-elt-run
            arguments:
              parameters:
                [
                  { name: command, value: "seed" },
                  { name: projectdir, value: "/code/00_src/psa/" },
                ]
          - name: hardrules
            dependencies: [seed]
            templateRef:
              name: wf-elt-run
              template: wf-elt-run
            arguments:
              parameters:
                [
                  { name: command, value: "run" },
                  { name: projectdir, value: "/code/00_src/fifa_hr/" },
                  { name: target, value: "ci" },
                ]
          - name: uefa
            templateRef:
              name: wf-elt-run
              template: wf-elt-run
            arguments:
              parameters:
                [
                  { name: command, value: "run" },
                  { name: projectdir, value: "/code/00_src/uefa_hr/" },
                ]
          - name: hardrules-test
            dependencies: [hardrules]
            templateRef:
              name: wf-elt-run
              template: wf-elt-run
            arguments:
              parameters:
                [
                  { name: command, value: "test" },
                  { name: projectdir, value: "/code/00_src/fifa_hr/" },
                  { name: target, value: "ci" },
                ]
          - name: datavault
            dependencies: [hardrules, deploy]
            templateRef:
              name: wf-dvb-run
              template: wf-dvb-run
            arguments:
              parameters:
                [{ name: JOBS, value: "JOBS=/code/01_dv/dvb/RAW_jobs.csv" }]
          - name: softrules
            dependencies: [datavault]
            templateRef:
              name: wf-elt-run
              template: wf-elt-run
            arguments:
              parameters:
                [
                  { name: command, value: "run" },
                  { name: projectdir, value: "/code/02_app/fifa_report/" },
                  { name: target, value: "ci" },
                ]
          - name: bdv
            dependencies: [softrules]
            templateRef:
              name: wf-dvb-run
              template: wf-dvb-run
            arguments:
              parameters:
                [{ name: JOBS, value: "JOBS=/code/01_dv/dvb/BDV_jobs.csv" }]
          - name: apps
            dependencies: [bdv]
            templateRef:
              name: wf-elt-run
              template: wf-elt-run
            arguments:
              parameters:
                [
                  { name: command, value: "run" },
                  { name: projectdir, value: "/code/02_app/fifa_report/" },
                  { name: target, value: "ci" },
                ]
          - name: apps-test
            dependencies: [apps]
            templateRef:
              name: wf-elt-run
              template: wf-elt-run
            arguments:
              parameters:
                [
                  { name: command, value: "test" },
                  { name: projectdir, value: "/code/02_app/fifa_report/" },
                  { name: target, value: "ci" },
                ]
